***[ AES32 5.0 Declarations for xBase++] ***

#define AES_BLOCK_SIZE           16 && block size of AES is fixed at 16 bytes
#define AES_KEY_SIZE             32 && key size is always 32 bytes(for 256-bit AES)

#define AES_GET_CONTROL_VERSION 101 && get AES control block version
#define AES_GET_CONTROL_SIZE    102 && get size of control block
#define AES_GET_VERSION         103 && get AES version
#define AES_GET_BUILD           104 && get AES build
#define AES_GET_SECURE_SIZE     105 && get size of secure random control block
#define AES_GET_REGISTRATION    201 && get registration string

#define AES_SET_PAD_BYTE        301 && set padding

#define AES_ECB_MODE              0 && use ECB mode(default)
#define AES_CBC_MODE              2 && use CBC mode

#define AES_ENCRYPT               0 && encrypt(default)
#define AES_DECRYPT               4 && decrypt

#define AES_PAD_ZERO              6 && pad with 0's
#define AES_PAD_SPACE             7 && pad with spaces(0x20)
#define AES_PAD_RANDOM            8 && pad with random values
#define AES_PAD_PKCS7             9 && pad according to PKCS7

#define AES_NIBBLE_METHOD         0 && use "nibble" method to create encryption key
#define AES_SHA256_METHOD         1 && use SHA 256 to create encryption key
#define AES_MIXED_METHOD          2 && do nibble method followed by SHA256 method
#define AES_PKCS7_MASK            1 && uses PKCS7 padding if bit = 1
#define AES_SET_SEED              1 && sets random number generator seed

*** error codes

#define AES_NOT_MULTIPLE         -2 && not multiple of 16 bytes
#define AES_BAD_KEY_DIR          -3 && key direction is invalid
#define AES_BAD_KEY_DATA         -4 && key data is invalid
#define AES_BAD_CIPHER_MODE      -5 && invalid cipher mode
#define AES_BAD_CIPHER_STATE     -6 && cipher not initialized
#define AES_BAD_BLOCK_LENGTH     -7 && invalid block length
#define AES_NOT_INITIALIZED      -8 && AES control block not initialized
#define AES_IS_CORRUPTED         -9 && AES control block is corrupted
#define AES_INTERNAL_ERROR      -10 && AES internal error
#define AES_BAD_PASS_LEN        -11 && password too short
#define AES_CANNOT_OPEN         -12 && cannot open file (for read)
#define AES_CANNOT_CREATE       -13 && cannot create file
#define AES_READ_ERROR          -14 && read error
#define AES_WRITE_ERROR         -15 && write error
#define AES_BAD_PAD_CHOICE      -16 && must be AES_PAD_*
#define AES_BAD_HEX_CHAR        -17 && bad hex character
#define AES_UNEXPECTED_CHAR     -18 && unexpected character
#define AES_ATTACH_CALL         -19 && aesAttach not called
#define AES_NULL_POINTER        -20 && unexpected null pointer
#define AES_BAD_METHOD          -21 && bad method
#define AES_BUFFER_TOO_SMALL    -22 && buffer is too small
#define AES_BUFFER_TOO_BIG      -23 && buffer is too big
#define AES_PKCS7_ERROR         -24 && PKCS7 padding error
#define AES_CANNOT_OPEN_WRITE   -25 && cannot open file (for write)
#define AES_CANNOT_CLOSE        -26 && cannot close file
#define AES_CANNOT_DELETE       -27 && cannot delete file

#define AES_ABORTED            -201
#define AES_KEYCODE            -202
#define AES_EXPIRED            -203

*** AES Functions

FUNCTION XaesAttach(nKeyCode,nFlags) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesAttach",nKeyCode,nFlags)

FUNCTION XaesByteToHex(cBuffer,nBufLen,cHexBuf)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesByteToHex",@cBuffer,nBufLen,@cHexBuf)

FUNCTION XaesDecryptBlocks(cControl,cData,nDataLen,cBuffer) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesDecryptBlocks",@cControl,@cData,nDataLen,@cBuffer)

FUNCTION XaesDecryptFile(cControl,cInputFile,cOutputFile)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesDecryptFile",@cControl,@cInputFile,@cOutputFile)

FUNCTION XaesEncryptBlocks(cControl,cData,nDataLen,cBuffer) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesEncryptBlocks",@cControl,@cData,nDataLen,@cBuffer) 

FUNCTION XaesEncryptFile(cControl,cInputFile,cOutputFile)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesEncryptFile",@cControl,@cInputFile,@cOutputFile)

FUNCTION XaesErrorText(nErrCode,cBuffer,nBufLen)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesErrorText",nErrCode,@cBuffer,nBufLen)

FUNCTION XaesGetInteger(cControl,nParamName)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesGetInteger",@cControl,nParamName)

FUNCTION XaesGetString(cControl,nParamName,cBuffer,nBufLen)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesGetString",@cControl,nParamName,@cBuffer,nBufLen)

FUNCTION XaesHexToByte(cHexBuf,cHexBytes,cByteBuf)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesHexToByte",@cHexBuf,cHexBytes,@cByteBuf)

FUNCTION XaesInitAES(cKeyBuf,cVector,nMode,nDirection,cControl)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesInitAES",@cKeyBuf,@cVector,nMode,nDirection,@cControl)

FUNCTION XaesMakeRandom(cBuffer,nBufSize)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesMakeRandom",@cBuffer,nBufSize)

FUNCTION XaesMakeUserKey(cUserPhrase,cKeyBuf,nFlags)  
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesMakeUserKey",@cUserPhrase,@cKeyBuf,nFlags) 

FUNCTION XaesPadBuffer(cBuffer,nBufLen,nPadControl)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesPadBuffer",@cBuffer,nBufLen,nPadControl)

FUNCTION XaesSleep(nMilliSecs)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesSleep",nMilliSecs)

FUNCTION XaesVerifyControl(cControl)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesVerifyControl",@cControl)

FUNCTION XaesXorBits(cXorBuf,nXorLen,cInBuf,cOutBuf,nBufLen)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesXorBits",@cXorBuf,nXorLen,@cInBuf,@cOutBuf,nBufLen)

FUNCTION XaesEncryptWrite(cControl,cData,nDataLen,cOutputFile)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesEncryptWrite",@cControl,@cData,nDataLen,@cOutputFile)

FUNCTION XaesReadDecrypt(cControl,cData,cBuffer,nBufLen)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesReadDecrypt",@cControl,@cData,@cBuffer,nBufLen)

FUNCTION XaesSha256(cData,cHash)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesSha256",@cData,@cHash)

FUNCTION XaesSha256Data(cData,nLength,cHash) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesSha256Data",@cData,nLength,@cHash) 

FUNCTION XaesSha256File(cFileName,cHash) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesSha256File",@cFileName,@cHash)

FUNCTION XaesEncryptBuffer(cControl,cInputBuf,nInputLen,cOutputBuf)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesEncryptBuffer",@cControl,@cInputBuf,nInputLen,@cOutputBuf)

FUNCTION XaesDecryptBuffer(cControl,cInputBuf,nInputLen,cOutputBuf)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesDecryptBuffer",@cControl,@cInputBuf,nInputLen,@cOutputBuf)

FUNCTION XaesRemovePad(cDataBuf,nDataLen) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesRemovePad",@cDataBuf,nDataLen) 

FUNCTION XaesSaltPass(nSaltSeed,nNbrSaltChars,cSaltOut,cPassInp,cPassOut) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesSaltPass",nSaltSeed,nNbrSaltChars,@cSaltOut,@cPassInp,@cPassOut) 

FUNCTION XaesSetInteger(cControl,nParamName,nParamValue) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesSetInteger",@cControl,nParamName,nParamValue) 

FUNCTION XaesShredFile(cFile,nDelFlag) 
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesShredFile",@cFile,nDelFlag )

FUNCTION XaesSecureRandom(cContext,cBuffer,nBufLen)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesSecureRandom",@cContext,@cBuffer,nBufLen)

FUNCTION XaesEncodeBase64(cDataBuf,nDataLen,cCodeBuf)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesEncodeBase64",@cDataBuf,nDataLen,@cCodeBuf)

FUNCTION XaesDecodeBase64(cCodeBuf,nCodeLen,cDataBuf)
RETURN DLLCALL("AES32.DLL",DLL_STDCALL,"aesDecodeBase64",@cCodeBuf,nCodeLen,@cDataBuf)

***[ End of AES32 Declarations ]***
